; 
    include \masm32\include\masm32rt.inc
    .586			
	include \masm32\macros\timers.asm

; 
; Entry ECX = Unsigned value of duration in milliseconds
; EDX = Pointer to ASCII output.

.data
  Divisors  dd  3600000, 60000, 1
  HrsFmt    db  "%d:", 0
  MinFmt    db  "%02d:", 0
  SecFmt    db  "%06d", 0
  Formats   dd  HrsFmt, MinFmt, SecFmt
  buff db 100 dup(0)
.code
align 16
Bin2Time proc

    push    edi
    push    esi
    push    ebx

    push    edx

    mov     esi, OFFSET Divisors
    mov     edi, edx
    mov     ebx, OFFSET Formats
    mov     edx, ecx
    xor     ecx, ecx
    mov     [edi], cl
    mov     cl, 3
  L18:
    push    ecx
    lodsd
    mov     ecx, eax
    mov     eax, edx
    xor     edx, edx
    idiv    ecx
    pop     ecx
    and     eax, eax
    jnz     L2C

    test    ch, 1
    je      L41
  L2C:
    or      ch, 1
    push    ecx
    push    edx

    push    eax
    push    dword ptr [ebx]
    push    edi
    call    wsprintfA
    add     esp, 0Ch

    add     edi, eax
    pop     edx
    pop     ecx
  L41:
    add     ebx, 4
    dec     cl
    jnz     L18

    pop     edx

    sub     edi, eax
    mov     esi, edi
    inc     esi
    lodsw
    stosw
    mov     al, 2Eh
    stosb

    cmp     byte ptr [edx], 30h
    jnz     L5B
    inc     edx
  L5B:
    pop     ebx
    pop     esi
    pop     edi
    ret
Bin2Time endp

; 

.data
    szUptimeFmt DB "%u days %02u:%02u:%02u.%u",0
.code
align 16
UpTime proc uses edx pszTimeString:DWORD, milliseconds:DWORD
    LOCAL Minutes:DWORD
    LOCAL Hours:DWORD
    LOCAL Days:DWORD

    xor ebx,ebx
    ;invoke GetTickCount
    mov eax, milliseconds

    xor edx,edx
    mov ecx,86400000 ; Milliseconds in one day
    div ecx
    mov [Days],eax

    mov eax,edx
    xor edx,edx
    mov ecx,3600000 ; Milliseconds in one hour
    div ecx
    mov [Hours],eax

    mov eax,edx
    xor edx,edx
    mov ecx,60000 ; Milliseconds in one minute

    div ecx
    mov [Minutes],eax

    ; convert to seconds with fraction
    push edx
    pop eax
    xor edx,edx
    mov ecx,1000
    div ecx

    invoke wsprintf,pszTimeString,ADDR szUptimeFmt,Days,Hours,Minutes,eax,edx

    ret
UpTime endp

; 
.data
align        16
days         DB "00 Days "
hours       DB "00:"
minutes   DB "00:"
seconds  DB "00."

.code
comment *Convert binary to time in ASCII by lingo*
option prologue:none                ; turn it off
option epilogue:none                 ;
align   16                                       ;
d2dtl   proc   ntime: DWORD     ; time in miliseconds
       mov        eax,     31B5D4h    ; 2^48 / 86400000
       mul         dword ptr [esp+1*4]   ; high 16 bits of edx = days, dx:eax = fractional days(hours,mins,sec)
       mov        [esp+1*4], ebx      ; saving ebx
       mov        ecx,   edx              ; high 16 bits of ecx-> days
       and         edx,   0FFFFh       ; edx-> fractional days
       shr         ecx,   10h              ; ecx-> days
       imul	      ecx,	ecx, 6666D8h
       mov	      ebx, 	3FFFFFFh   ;  
	   and	      ebx, 	ecx
	   shr	      ecx, 	1Ah;+10h
	   lea	      ebx, 	[ebx+ebx*4]
	   add	      ecx, 	3030h
	   shr	      ebx, 	19h
	   add	      ch,   	 bl
	   mov        word  ptr days, cx ; saving days
       mov       ebx,    eax               ;
       mov       ecx,    edx               ;
       add        eax,    eax               ;
       adc        edx,    edx               ;
       add       eax,     ebx               ;
       adc       edx,     ecx               ;
       shrd     eax, edx, 0Dh          ;
	   mov	    ecx,     3FFFFFFh
       shr       edx,     0Dh               ; edx = hours, eax = fractions(min,sec)
       mov     ebx,      eax               ;
       imul	    edx,	edx, 6666D8h 		
       shr       ebx,     4                    ;
       sub      eax,     ebx                ;
	   and	    ecx, 	edx
	   shr	    edx, 	1Ah
	   lea	    ecx, 	[ecx+ecx*4]
	   add	    edx, 	3030h
	   shr	    ecx, 	19h
	   add	    dh,   	cl
       mov     ecx,      eax                ;
       and      eax,      3FFFFFFh     ; eax-> low 26 bits;(min:sec)
       shr       ecx,      1Ah                ;
       mov     ebx,      eax                       
       imul	    ecx,	ecx, 6666D8h 		
	   mov      word   ptr hours, dx ; saving hours
	   shr        ebx,    4 
	   mov	    edx, 	3FFFFFFh
	   sub       eax,    ebx 
	   and	    edx, 	ecx
	   shr	    ecx, 	1Ah
	   lea	    edx, 	[edx+edx*4]
	   add	    ecx, 	3030h
	   shr	    edx, 	19h
	   shr        eax,    14h   
	   add	    ch,   	dl
       imul	    eax,	    eax, 6666D8h
       mov      word   ptr minutes, cx ; saving minutes
       mov	    edx, 	3FFFFFFh
	   and	    edx, 	eax
	   shr	    eax, 	1Ah
	   lea	    edx, 	[edx+edx*4]
	   add	    eax, 	3030h
	   shr	    edx, 	19h
	   mov     ebx,     [esp+1*4] ; restoring ebx
	   add	    ah,   	dl
	   mov      word   ptr seconds, ax ; saving seconds       
       ret         1*4                       ;
d2dtl  endp                              ;
option prologue:prologuedef    ;  turn back on the defaults
option epilogue:epiloguedef     ;
; 

; 

.data
szDays  DB "00 Days "
szHours DB "00:"
szMin   DB "00:"
szSec   DB "00."
szFrac  DB 0,0,0,0,0,0
.code

align 16
ConvertTime proc ms:DWORD

    ;invoke GetTickCount

    ;mov esi,eax
    mov esi, ms

    ; Days
    mov edx, 3335999724
    mul edx
    shr edx, 26

    mov eax,edx
    aam
    add eax,3030h
    bswap eax
    shr eax,16
    mov WORD PTR [szDays],ax

    ; Hours
    mov eax,86400000
    mul edx
    sub esi,eax
    mov eax,esi

    mov edx, 2501999793
    mul edx
    mov eax,edx
    shr edx, 21

    mov eax,edx
    aam
    add eax,3030h
    bswap eax
    shr eax,16
    mov WORD PTR [szHours],ax

    ; Minutes
    mov eax,3600000
    mul edx
    sub esi,eax
    mov eax,esi

    mov edx, 2345624806
    mul edx
    mov eax,edx
    shr edx, 15

    mov eax,edx
    aam
    add eax,3030h
    bswap eax
    shr eax,16
    mov WORD PTR [szMin],ax

    ; Seconds
    mov eax,60000
    mul edx
    sub esi,eax
    mov eax,esi

    mov edx, 2199023256
    mul edx
    mov eax,edx
    shr edx, 9

    mov eax,edx
    aam
    add eax,3030h
    bswap eax
    shr eax,16
    mov WORD PTR [szSec],ax

    ; Fraction
   ; mov eax,1000
   ; mul edx
   ; sub esi,eax
   ; mov eax,esi
   ; mov edx, 3435973837
   ; mul edx
   ; shr edx, 3

   ; mov eax,edx
   ; aam
   ; add eax,3030h
   ; bswap eax
   ; shr eax,16
   ; mov WORD PTR [szFrac],ax
    ret
ConvertTime endp

.data
    szFmt DB "%u days %02u:%02u:%02u",0
.code
; 
start:
; 
    ;function tests



    invoke Sleep, 3000


    counter_begin 1000, HIGH_PRIORITY_CLASS
      mov ecx, 12345678
      mov edx, OFFSET buff
      call Bin2Time
    counter_end
    print ustr$(eax)," cycles, Bin2Time",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      invoke UpTime, ADDR buff, 12345678
    counter_end
    print ustr$(eax)," cycles, UpTime",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      invoke d2dtl,  12345678
      counter_end
    print ustr$(eax)," cycles, d2dtl-lingo",13,10
  
    counter_begin 1000, HIGH_PRIORITY_CLASS
      invoke ConvertTime, 12345678
    counter_end
    print ustr$(eax)," cycles, ConvertTime-NightWare",13,10

    inkey "Press any key to exit..."
    exit
; 
end start



